Bug 1379814 - Review Request: vulkan - Vulkan loader and validation layers
Summary: Review Request: vulkan - Vulkan loader and validation layers
Keywords:
Status: CLOSED ERRATA
Alias: None
Product: Fedora
Classification: Fedora
Component: Package Review
Version: rawhide
Hardware: All
OS: Linux
medium
medium
Target Milestone: ---
Assignee: Michael Cronenworth
QA Contact: Fedora Extras Quality Assurance
URL:
Whiteboard:
Depends On:
Blocks: 1356229
TreeView+ depends on / blocked
 
Reported: 2016-09-27 18:01 UTC by leigh scott
Modified: 2016-10-09 09:22 UTC (History)
3 users (show)

Fixed In Version:
Doc Type: If docs needed, set a value
Doc Text:
Clone Of:
Environment:
Last Closed: 2016-10-05 06:22:18 UTC
Type: ---
mike: fedora-review+


Attachments (Terms of Use)

Description leigh scott 2016-09-27 18:01:58 UTC
Spec URL: https://leigh123linux.fedorapeople.org/pub/review/vulkan/1/vulkan.spec
SRPM URL: https://leigh123linux.fedorapeople.org/pub/review/vulkan/1/vulkan-1.0.26.0-2.fc24.src.rpm
Description: 

Vulkan is a new high-performance rendering and compute API from the Khronos Group. This package contains the driver loader library, validation layers, and vulkaninfo sample utility for the Vulkan API.

Fedora Account System Username: leigh123linux

Comment 1 Michael Cronenworth 2016-09-27 18:09:42 UTC
Thanks, Leigh. Starting my review.

Comment 2 Michael Cronenworth 2016-09-27 19:24:12 UTC
Package Review
==============

Legend:
[x] = Pass, [!] = Fail, [-] = Not applicable, [?] = Not evaluated
[ ] = Manual review needed


Issues:
=======
- Khronos changed from MIT to Apache 2.0 a few months ago.
  Please update the license to ASL 2.0.
  Upstream commit: 43b53e83705f02245da6ae61e31273866a35b833
- The unversioned libraries need to go directly in %{_libdir} 
  and not a sub-directory according to the previous review.
  Previous review: https://bugzilla.redhat.com/show_bug.cgi?id=1308985
- The vkjson_info utility is being compiled but not installed.
- Package uses either %{buildroot} or $RPM_BUILD_ROOT
  Note: Using both %{buildroot} and $RPM_BUILD_ROOT
  See: http://fedoraproject.org/wiki/Packaging/Guidelines#macros


===== MUST items =====

C/C++:
[x]: Package does not contain kernel modules.
[x]: Package contains no static executables.
[!]: Development (unversioned) .so files in -devel subpackage, if present.
     Note: Unversioned so-files in private %_libdir subdirectory (see
     attachment). Verify they are not in ld path.
[x]: Header files in -devel subpackage, if present.
[x]: ldconfig called in %post and %postun if required.
[x]: Package does not contain any libtool archives (.la)
[x]: Rpath absent or only used for internal libs.

Generic:
[x]: Package is licensed with an open-source compatible license and meets
     other legal requirements as defined in the legal section of Packaging
     Guidelines.
[!]: License field in the package spec file matches the actual license.
     Note: Checking patched sources after %prep for licenses. Licenses
     found: "Apache (v2.0)", "GPL (v2 or later)", "GPL (v3 or later)",
     "Unknown or generated", "MIT/X11 (BSD like)", "BSD (3 clause)". 80
     files have unknown license. Detailed output of licensecheck in
     /home/michael/Projects/1379814-vulkan/licensecheck.txt
[x]: License file installed when any subpackage combination is installed.
[x]: Package does not own files or directories owned by other packages.
[x]: %build honors applicable compiler flags or justifies otherwise.
[x]: Package contains no bundled libraries without FPC exception.
[x]: Changelog in prescribed format.
[x]: Sources contain only permissible code or content.
[-]: Package contains desktop file if it is a GUI application.
[x]: Development files must be in a -devel package
[x]: Package uses nothing in %doc for runtime.
[!]: Package consistently uses macros (instead of hard-coded directory
     names).
[x]: Package is named according to the Package Naming Guidelines.
[x]: Package does not generate any conflict.
[x]: Package obeys FHS, except libexecdir and /usr/target.
[-]: If the package is a rename of another package, proper Obsoletes and
     Provides are present.
[x]: Requires correct, justified where necessary.
[x]: Spec file is legible and written in American English.
[-]: Package contains systemd file(s) if in need.
[x]: Useful -debuginfo package or justification otherwise.
[x]: Package is not known to require an ExcludeArch tag.
[x]: Large documentation must go in a -doc subpackage. Large could be size
     (~1MB) or number of files.
     Note: Documentation size is 10240 bytes in 1 files.
[!]: Package complies to the Packaging Guidelines
[x]: Package successfully compiles and builds into binary rpms on at least
     one supported primary architecture.
[x]: Package installs properly.
[x]: Rpmlint is run on all rpms the build produces.
     Note: There are rpmlint messages (see attachment).
[x]: If (and only if) the source package includes the text of the
     license(s) in its own file, then that file, containing the text of the
     license(s) for the package is included in %license.
[x]: Package requires other packages for directories it uses.
[x]: Package must own all directories that it creates.
[x]: Package does not run rm -rf %{buildroot} (or $RPM_BUILD_ROOT) at the
     beginning of %install.
[x]: %config files are marked noreplace or the reason is justified.
[x]: Macros in Summary, %description expandable at SRPM build time.
[x]: Dist tag is present.
     Note: Multiple Release: tags found
[x]: Package does not contain duplicates in %files.
[x]: Permissions on files are set properly.
[x]: Package use %makeinstall only when make install DESTDIR=... doesn't
     work.
[x]: Package is named using only allowed ASCII characters.
[x]: No %config files under /usr.
[x]: Package does not use a name that already exists.
[x]: Package is not relocatable.
[x]: Sources used to build the package match the upstream source, as
     provided in the spec URL.
[x]: Spec file name must match the spec package %{name}, in the format
     %{name}.spec.
[x]: File names are valid UTF-8.
[x]: Packages must not store files under /srv, /opt or /usr/local

===== SHOULD items =====

Generic:
[x]: Uses parallel make %{?_smp_mflags} macro.
[x]: If the source package does not include license text(s) as a separate
     file from upstream, the packager SHOULD query upstream to include it.
[x]: Final provides and requires are sane (see attachments).
[x]: Fully versioned dependency in subpackages if applicable.
[x]: Package functions as described.
[x]: Latest version is packaged.
[x]: Package does not include license text files separate from upstream.
[x]: Patches link to upstream bugs/comments/lists or are otherwise
     justified.
[x]: Scriptlets must be sane, if used.
[-]: Description and summary sections in the package spec file contains
     translations for supported Non-English languages, if available.
[x]: Package should compile and build into binary rpms on all supported
     architectures.
[-]: %check is present and all tests pass.
[x]: Packages should try to preserve timestamps of original installed
     files.
[x]: Reviewer should test that the package builds in mock.
[x]: Buildroot is not present
[x]: Package has no %clean section with rm -rf %{buildroot} (or
     $RPM_BUILD_ROOT)
[x]: No file requires outside of /etc, /bin, /sbin, /usr/bin, /usr/sbin.
[x]: Packager, Vendor, PreReq, Copyright tags should not be in spec file
[x]: Sources can be downloaded from URI in Source: tag
[x]: SourceX is a working URL.
[x]: Spec use %global instead of %define unless justified.

===== EXTRA items =====

Generic:
[x]: Rpmlint is run on debuginfo package(s).
     Note: No rpmlint messages.
[x]: Rpmlint is run on all installed packages.
     Note: There are rpmlint messages (see attachment).
[x]: Large data in /usr/share should live in a noarch subpackage if package
     is arched.
[x]: Spec file according to URL is the same as in SRPM.


Rpmlint
-------
Checking: vulkan-1.0.26.0-2.fc26.x86_64.rpm
          vulkan-devel-1.0.26.0-2.fc26.x86_64.rpm
          vulkan-filesystem-1.0.26.0-2.fc26.noarch.rpm
          vulkan-debuginfo-1.0.26.0-2.fc26.x86_64.rpm
          vulkan-1.0.26.0-2.fc26.src.rpm
vulkan.x86_64: W: name-repeated-in-summary C Vulkan
vulkan.x86_64: W: no-manual-page-for-binary vulkaninfo
vulkan-devel.x86_64: W: only-non-binary-in-usr-lib
vulkan-devel.x86_64: W: no-documentation
vulkan-filesystem.noarch: W: no-documentation
vulkan.src: W: name-repeated-in-summary C Vulkan
5 packages and 0 specfiles checked; 0 errors, 6 warnings.




Rpmlint (debuginfo)
-------------------
Checking: vulkan-debuginfo-1.0.26.0-2.fc26.x86_64.rpm
1 packages and 0 specfiles checked; 0 errors, 0 warnings.





Rpmlint (installed packages)
----------------------------
vulkan-devel.x86_64: W: only-non-binary-in-usr-lib
vulkan-devel.x86_64: W: no-documentation
vulkan-filesystem.noarch: W: no-documentation
vulkan.x86_64: W: name-repeated-in-summary C Vulkan
vulkan.x86_64: W: no-manual-page-for-binary vulkaninfo
4 packages and 0 specfiles checked; 0 errors, 5 warnings.



Requires
--------
vulkan-devel (rpmlib, GLIBC filtered):
    libvulkan.so.1()(64bit)
    vulkan(x86-64)

vulkan-debuginfo (rpmlib, GLIBC filtered):

vulkan-filesystem (rpmlib, GLIBC filtered):

vulkan (rpmlib, GLIBC filtered):
    /sbin/ldconfig
    config(vulkan)
    ld-linux-x86-64.so.2()(64bit)
    libVkLayer_utils.so()(64bit)
    libX11.so.6()(64bit)
    libc.so.6()(64bit)
    libdl.so.2()(64bit)
    libgcc_s.so.1()(64bit)
    libgcc_s.so.1(GCC_3.0)(64bit)
    libm.so.6()(64bit)
    libpthread.so.0()(64bit)
    libstdc++.so.6()(64bit)
    libstdc++.so.6(CXXABI_1.3)(64bit)
    libstdc++.so.6(CXXABI_1.3.5)(64bit)
    libvulkan.so.1()(64bit)
    libxcb.so.1()(64bit)
    rtld(GNU_HASH)
    vulkan-filesystem



Provides
--------
vulkan-devel:
    vulkan-devel
    vulkan-devel(x86-64)

vulkan-debuginfo:
    vulkan-debuginfo
    vulkan-debuginfo(x86-64)

vulkan-filesystem:
    vulkan-filesystem

vulkan:
    config(vulkan)
    libVkLayer_core_validation.so()(64bit)
    libVkLayer_image.so()(64bit)
    libVkLayer_object_tracker.so()(64bit)
    libVkLayer_parameter_validation.so()(64bit)
    libVkLayer_swapchain.so()(64bit)
    libVkLayer_test.so()(64bit)
    libVkLayer_threading.so()(64bit)
    libVkLayer_unique_objects.so()(64bit)
    libVkLayer_utils.so()(64bit)
    libVkLayer_wrap_objects.so()(64bit)
    libvulkan.so.1()(64bit)
    vulkan
    vulkan(x86-64)



Unversioned so-files
--------------------
vulkan: /usr/lib64/vulkan/libVkLayer_core_validation.so
vulkan: /usr/lib64/vulkan/libVkLayer_image.so
vulkan: /usr/lib64/vulkan/libVkLayer_object_tracker.so
vulkan: /usr/lib64/vulkan/libVkLayer_parameter_validation.so
vulkan: /usr/lib64/vulkan/libVkLayer_swapchain.so
vulkan: /usr/lib64/vulkan/libVkLayer_test.so
vulkan: /usr/lib64/vulkan/libVkLayer_threading.so
vulkan: /usr/lib64/vulkan/libVkLayer_unique_objects.so
vulkan: /usr/lib64/vulkan/libVkLayer_utils.so
vulkan: /usr/lib64/vulkan/libVkLayer_wrap_objects.so

Source checksums
----------------
https://github.com/KhronosGroup/SPIRV-Tools/archive/860030feab94360b9bf64cf486b44cffd62bdea8.tar.gz#/SPIRV-Tools-860030feab94360b9bf64cf486b44cffd62bdea8.tar.gz :
  CHECKSUM(SHA256) this package     : 83b6de3927e156db76d417c5d972ea25598778d8063ca1d136c295c7af06c953
  CHECKSUM(SHA256) upstream package : 83b6de3927e156db76d417c5d972ea25598778d8063ca1d136c295c7af06c953
https://github.com/KhronosGroup/SPIRV-Headers/archive/33d41376d378761ed3a4c791fc4b647761897f26.tar.gz#/SPIRV-Headers-33d41376d378761ed3a4c791fc4b647761897f26.tar.gz :
  CHECKSUM(SHA256) this package     : 6bd309be877f81516202fd1df3192b53f787936e08b11c40249da44ef09ed65d
  CHECKSUM(SHA256) upstream package : 6bd309be877f81516202fd1df3192b53f787936e08b11c40249da44ef09ed65d
https://github.com/KhronosGroup/Vulkan-LoaderAndValidationLayers/archive/sdk-1.0.26.0.tar.gz#/Vulkan-LoaderAndValidationLayers-sdk-1.0.26.0.tar.gz :
  CHECKSUM(SHA256) this package     : 40a350f7ccec532187adf95990126b86053dfaa00d70ad2f24dc2c6591a96312
  CHECKSUM(SHA256) upstream package : 40a350f7ccec532187adf95990126b86053dfaa00d70ad2f24dc2c6591a96312
https://github.com/KhronosGroup/glslang/archive/cfd7ce87cd10191c3d5afec077865c7c6dc9dd77.tar.gz#/glslang-cfd7ce87cd10191c3d5afec077865c7c6dc9dd77.tar.gz :
  CHECKSUM(SHA256) this package     : 8868cad9200bae81c1d3214b03bad19afd043fea1566c6abfc100c3d7cc180a2
  CHECKSUM(SHA256) upstream package : 8868cad9200bae81c1d3214b03bad19afd043fea1566c6abfc100c3d7cc180a2


Generated by fedora-review 0.6.1 (f03e4e7) last change: 2016-05-02
Command line :/usr/bin/fedora-review -b 1379814 -m fedora-rawhide-x86_64
Buildroot used: fedora-rawhide-x86_64
Active plugins: Generic, Shell-api, C/C++
Disabled plugins: Java, Python, fonts, SugarActivity, Ocaml, Perl, Haskell, R, PHP
Disabled flags: EXARCH, DISTTAG, EPEL5, BATCH, EPEL6

Comment 3 Michael Cronenworth 2016-09-27 19:28:30 UTC
One thing I forgot to ask: Why is there a BR for systemd-devel? It should not be required.

Comment 4 Michael Cronenworth 2016-09-27 19:31:20 UTC
(In reply to Michael Cronenworth from comment #3)
> One thing I forgot to ask: Why is there a BR for systemd-devel? It should
> not be required.

Nevermind. Ignore this. It requires udev.

Comment 5 leigh scott 2016-09-27 22:46:49 UTC
Spec URL: https://leigh123linux.fedorapeople.org/pub/review/vulkan/2/vulkan.spec

SRPM URL: https://leigh123linux.fedorapeople.org/pub/review/vulkan/2/vulkan-1.0.26.0-3.fc24.src.rpm


* Tue Sep 27 2016 Leigh Scott <leigh123linux@googlemail.com> - 1.0.26.0-3
- Move unversioned libraries
- Disable vkjson build
- Fix license tag

Comment 6 Michael Cronenworth 2016-09-28 00:28:52 UTC
In regards to vkjson: I actually meant you should include the utility as it was requested in the previous review. I'm not sure how important it is though. I'll leave that up to you. The changes look good.

APPROVED

Comment 7 Gwyn Ciesla 2016-09-28 12:29:29 UTC
Package request has been approved: https://admin.fedoraproject.org/pkgdb/package/rpms/vulkan

Comment 8 leigh scott 2016-09-28 15:24:43 UTC
(In reply to Michael Cronenworth from comment #6)
> In regards to vkjson: I actually meant you should include the utility as it
> was requested in the previous review. I'm not sure how important it is
> though. I'll leave that up to you. The changes look good.
> 
> APPROVED

Thank you for the review, package imported and built for all branches.

As for vkjson, I will include it when someone can prove it's actually used.
It seems to provide similar info to vulkaninfo but different values (I doubt the vkjson info is correct as most values are 0).

Comment 9 Fedora Update System 2016-09-28 20:52:03 UTC
vulkan-1.0.26.0-3.fc25 has been pushed to the Fedora 25 testing repository. If problems still persist, please make note of it in this bug report.
See https://fedoraproject.org/wiki/QA:Updates_Testing for
instructions on how to install test updates.
You can provide feedback for this update here: https://bodhi.fedoraproject.org/updates/FEDORA-2016-89bbc07132

Comment 10 Fedora Update System 2016-09-29 01:52:22 UTC
vulkan-1.0.26.0-3.fc23 has been pushed to the Fedora 23 testing repository. If problems still persist, please make note of it in this bug report.
See https://fedoraproject.org/wiki/QA:Updates_Testing for
instructions on how to install test updates.
You can provide feedback for this update here: https://bodhi.fedoraproject.org/updates/FEDORA-2016-ea8dcc9d15

Comment 11 Fedora Update System 2016-09-29 02:49:27 UTC
vulkan-1.0.26.0-3.fc24 has been pushed to the Fedora 24 testing repository. If problems still persist, please make note of it in this bug report.
See https://fedoraproject.org/wiki/QA:Updates_Testing for
instructions on how to install test updates.
You can provide feedback for this update here: https://bodhi.fedoraproject.org/updates/FEDORA-2016-d52c05442d

Comment 12 Fedora Update System 2016-10-05 06:22:18 UTC
vulkan-1.0.26.0-3.fc24 has been pushed to the Fedora 24 stable repository. If problems still persist, please make note of it in this bug report.

Comment 13 Fedora Update System 2016-10-09 02:48:06 UTC
vulkan-1.0.26.0-3.fc25 has been pushed to the Fedora 25 stable repository. If problems still persist, please make note of it in this bug report.

Comment 14 Fedora Update System 2016-10-09 09:22:44 UTC
vulkan-1.0.26.0-3.fc23 has been pushed to the Fedora 23 stable repository. If problems still persist, please make note of it in this bug report.


Note You need to log in before you can comment on or make changes to this bug.